"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InjectRepository = void 0;
const common_1 = require("@nestjs/common");
const sharding_base_entity_1 = require("../sharding-base-entity");
const MetadataUtils_1 = require("typeorm/metadata-builder/MetadataUtils");
const InjectRepository = (entity) => {
    const isSharded = MetadataUtils_1.MetadataUtils.getInheritanceTree(entity).includes(sharding_base_entity_1.ShardingBaseEntity);
    const token = isSharded ? `ShardingRepositoryService<${entity.name}>` : `TypeormRepositoryService<${entity.name}>`;
    return (0, common_1.Inject)(token);
};
exports.InjectRepository = InjectRepository;
