"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RepositoryService = void 0;
const typeorm_1 = require("typeorm");
const sharding_base_entity_1 = require("../sharding-base-entity");
const MetadataUtils_1 = require("typeorm/metadata-builder/MetadataUtils");
const sharding_repository_service_1 = require("./sharding-repository-service");
const typeorm_repository_service_1 = require("./typeorm-repository-service");
class RepositoryService {
    static of(entityType) {
        if (MetadataUtils_1.MetadataUtils.getInheritanceTree(entityType).includes(sharding_base_entity_1.ShardingBaseEntity))
            return new sharding_repository_service_1.ShardingRepositoryService(entityType);
        else
            return new typeorm_repository_service_1.TypeormRepositoryService(entityType);
    }
}
exports.RepositoryService = RepositoryService;
{
    //To check if ShardingBaseEntity conforms to AbstractRepositoryService interface.
    const __VALIDATION1__ = sharding_base_entity_1.ShardingBaseEntity;
    const __VALIDATION2__ = typeorm_1.BaseEntity;
}
