import { EntityOptions } from 'typeorm';
import { ShardingType } from './types/typeorm-sharding.type';
export interface RangeShardingEntityOptions<ENTITY, KEY_TYPE> extends EntityOptions {
    type: ShardingType.RANGE;
    findShard: (entity: ENTITY, minKey: KEY_TYPE, maxKey: KEY_TYPE) => boolean;
    findShardById: (id: any, minKey: KEY_TYPE, maxKey: KEY_TYPE) => boolean;
}
export interface ListShardingEntityOptions<ENTITY, KEY_TYPE> extends EntityOptions {
    type: ShardingType.LIST;
    findShard: (entity: ENTITY, shardingKey: KEY_TYPE) => boolean;
}
export declare type ShardingEntityOptions<ENTITY, KEY_TYPE> = RangeShardingEntityOptions<ENTITY, KEY_TYPE> | ListShardingEntityOptions<ENTITY, KEY_TYPE>;
export declare function ShardingEntity<ENTITY, KEY_TYPE = number>(options: ShardingEntityOptions<ENTITY, KEY_TYPE>): (target: Function) => void;
